/*
 * isdrush - load beta pictures (SCSI Direct Read)
 *   Copyright (C)1999 Tachibana Eriko
 */

#include <sys/iocs.h>

#include "isd_header.h"
#include "sdr.h"


/* Function */
int
sdr_beta (SDR* sdr, int frame_num, int frame_size, char* buf)
{
  IsdFrameHeader* hed = (IsdFrameHeader*) buf;

  while (--frame_num >= 0
	&& SDRread (sdr, buf, frame_size) == frame_size)
    {
      unsigned char* gvram = hed->gvram;
      unsigned long* g_data = (unsigned long*) hed->g_data;
      unsigned short y = hed->y_length;

      do
	{
	  unsigned long* p = (unsigned long*) gvram;
	  unsigned short x = hed->x_length / 2;

	  /* PC] */
	  do
	    *p++ = *g_data++;
	  while (--x);

	  gvram += hed->x_offset;
	}
      while (--y);

      if (*(short*)0x812 && _iocs_b_keysns () && (_iocs_b_keyinp () & 0xff) == 0x1b)
	return _iocs_b_sftsns () & 1;	/* ESC ĂI */
    }

  return 0;
}

/* EOF */
